﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private mqtt As MqttClient
	
	Private serializator As B4XSerializator
	Private mqttConnected As Boolean
	Public leds As List
	Private requestAll As Boolean
End Sub

Sub Service_Create
	mqtt.Initialize("mqtt", "tcp://192.168.0.6:51044", "android")
	mqtt.Connect
	leds.Initialize
	For i = 0 To 8
		leds.Add(False)
	Next
End Sub

Sub mqtt_Connected (Success As Boolean)
	Log("mqtt_connected: " & Success)
	mqttConnected = Success
	If Success Then
		mqtt.Subscribe("state/#", 0)
		requestAll = True
		mqtt.Publish("state/request_all", Array As Byte())
	Else
		Log(LastException)
	End If
End Sub

Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Dim m As Map
	If Topic = "state" Then
		Dim kv As KeyValue = serializator.ConvertBytesToObject(Payload)
		m = CreateMap(kv.Key: kv.Value)
	Else if Topic = "state/all" Then
		If requestAll = False Then Return
		requestAll = False
		m = serializator.ConvertBytesToObject(Payload)
	Else
		Return
	End If
	For Each k As String In m.Keys
		Dim value As Boolean = m.Get(k)
		If k.Contains("led") Then
			Dim ledNumber As Int
			If k.StartsWith("pi") Then
				Dim s As String = k.CharAt(6)
				ledNumber = s
			Else
				ledNumber = 8
			End If
			leds.Set(ledNumber, value)
		Else
			CallSub2(Main, "AppendLog", k & ": " & value)
		End If
	Next
	CallSub(Main, "UpdateLeds")
End Sub

Sub switch_ValueChanged (KeyValue As KeyValue)
	If mqttConnected Then
		mqtt.Publish("state", serializator.ConvertObjectToBytes(KeyValue))	
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
